;**********************************************************************
;                                                                     *
;    FD-2 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:       TMR1WU18.ASM                                      *
;    Dtum:         2002.09.23.                                       *
;    Verziszm:    V1.0                                              *
;    #2                                                               *
;                                                                     *
;    Szerz:        Kolinger Attila                                   *
;    Cg neve:      ChipCAD kft.                                      *
;    E-mail:        info@chipcad.hu                                   *
;                                                                     *
;**********************************************************************
;                                                                     *
;    BRESZTS TMR1 TLCSORDULSRA (DEMO PROGRAM)                     *
;    --------------------------------------------                     *
;    A Timer1 aszinkron mdban fut s 4 mp-knt megszaktst kr.     *
;    4 mp idztssel villogtatja a LED-eket.                         *
;                                                                     *
;**********************************************************************
;
;

        #include BEALLIT.INC                    ; ltalnos belltsok (proc, fejleszt, stb.)

;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
;------------------------------------- FPROGRAM -------------------------------
;------------------------------------------------------------------------------
;
        org     KezdVect                        ; reset vektor
        #ifdef ICD
            nop                                 ; MPLAB-ICD miatt
        #endif            

        org     KezdVect+8                        ; reset vektor
            retfie
;------------------------------------------------------------------------------
; I/O portok konfigurlsa
;
Start
                movlw   14
                movwf   ADCON1          ; RA0 analg bemenet !!!
                setf    TRISA           ; PORTA bemenet, (default!)
                setf    TRISC           ; PORTC bemenet, (default!)
                clrf    TRISD           ; PORTD kimenet
                movlw   1
                movwf   PIE1            ; TMR1 megszakts engedlyezs
                movlw   0x55
                movwf   LATD
;------------------------------------------------------------------------------
; TIMER1 idzt konfigurlsa
;
                movlw   B'00011110'     ; Timer1 bellts: TMR1 oszc. eng.,
                movwf   T1CON           ; eloszt= 1:2, aszinkron md
                clrf    INTCON          ; megszaktsok tiltsa
                bcf             T1CON,TMR1ON    ; Timer1 megllts
                bcf             PIR1,TMR1IF     ; Timer1 IT flag trls
                clrf    TMR1H           ; Timer1 trls, gy 4 mp mlva breszt
                clrf    TMR1L           ;
                movlw   64              ; PEIE=1
                movwf   INTCON          ; Timer1 IT engedlyezs
                bsf             T1CON,TMR1ON    ; Timer1 start
;------------------------------------------------------------------------------
Loop            sleep
                nop
                nop                     ; breds SLEEP-bl
                bcf     PIR1,TMR1IF     ; Timer1 IT flag trls
                movlw   B'11111111'
                xorwf   LATD,1          ; ellenkez LED-ek vilgtanak
                goto    Loop            ; vissza SLEEP-be
;------------------------------------------------------------------------------
                end

