;**********************************************************************
;                                                                     *
;    FD-2 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:       WAKEUP18.ASM                                      *
;    Dtum:         2002.09.23.                                       *
;    Verziszm:    V1.0                                              *
;    #2                                                               *
;                                                                     *
;    Szerz:        Kolinger Attila                                   *
;    Cg neve:      ChipCAD kft.                                      *
;    E-mail:        info@chipcad.hu                                   *
;                                                                     *
;**********************************************************************
;                                                                     *
;    BRESZTS PORTB JELSZINT VLTOZSRA                              *
;    -----------------------------------                              *
;    1/ SLEEP llapotban csak az RD0 kivezetsre kttt LED vilgt,  *
;       breszts utn mindegyik.                                     *
;    2/ Csak az RB0-ra kttt K0 s K1 gombok bresztenek.            *
;    3/ Fordtott port konfigurls esetn RB0 megszakts is         *
;       bresztheti a mikrovezrlt!                                  *
;                                                                     *
;**********************************************************************
;
;


        #include BEALLIT.INC                    ; ltalnos belltsok (proc, fejleszt, stb.)



;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
;------------------------------------- FPROGRAM ------------------------------
;------------------------------------------------------------------------------
;
        org     KezdVect                        ; reset vektor
        #ifdef ICD
            nop                                 ; MPLAB-ICD miatt
        #endif            
;-------------------------------------------------------------------------------
; PORTA, PORTB, PORTD konfigurlsa
;
                movlw   14
                movwf   ADCON1          ; RA0 analg bemenet !!!
                movlw   B'00111111'     ; PORTA bemenet
                movwf   TRISA
                movlw   B'11110000'     ; RB0..3 kimenet, RB4..7 bemenet
                movwf   TRISB
                clrf    TRISD           ; PORTD kimenet
                bcf     INTCON2,NOT_RBPU        ; felhz ellenllsok konfigurlsa
;------------------------------------------------------------------------------
Start           rcall   InitRB
                movlw   B'00000001'
                movwf   LATD
                sleep
                nop
                setf    PORTD
                rcall   InitRB
                sleep
                nop
Stop
;------------------------------------------------------------------------------
                bra     Start
;
;
;------------------------------------------------------------------------------
;------------------------------------ SZUBRUTINOK -----------------------------
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; Elkszts a PORTB szintltozs megszaktsra.
;
InitRB          movlw   B'11111110'
                movwf   LATB
                bcf     INTCON,RBIE     ; PORTB megszakts tiltsa
                movf    PORTB,0         ; PORTB beolvass (s trols)
                bcf     INTCON,RBIF     ; megszakts flag trls
                bsf     INTCON,RBIE     ; PORTB szintvltozs IT engedlyezs
                return
;------------------------------------------------------------------------------
                end


