;**********************************************************************
;                                                                     *
;    FD-2 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:       WDT18.ASM                                         *
;    Dtum:         2002.09.23.                                       *
;    Verziszm:    V1.0                                              *
;    #2                                                               *
;                                                                     *
;    Szerz:        Kolinger Attila                                   *
;    Cg neve:      ChipCAD kft.                                      *
;    E-mail:        info@chipcad.hu                                   *
;                                                                     *
;**********************************************************************
;                                                                     *
;    WATCHDOG TIMER DEMONSTRCIS PROGRAM                             *
;    ------------------------------------                             *
;    A program segtsgvel a WDT mkdse tanulmnyozhat:           *
;    1/ SLEEP llapotban az pratlan sorszm LED-ek vilgtanak.     *
;    2/ SLEEP llapotbl a WDT tlcsorduls breszt (2,3s), s        *
;       ezutn a pros sorszm LED-ek vilgtanak.                   *
;    3/ A kvetkez WDT tlcsorduls RESET-eli a mikrovezrlt!       *
;       (jabb 2,3s letelte utn)                                     *
;                                                                     *
;**********************************************************************
;
;

        #include BEALLIT.INC                    ; ltalnos belltsok (proc, fejleszt, stb.)


;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
;------------------------------------- FPROGRAM ------------------------------
;------------------------------------------------------------------------------
;
        org     KezdVect                        ; reset vektor
        #ifdef ICD
            nop                                 ; MPLAB-ICD miatt
        #endif            
                movlw   14
                movwf   ADCON1          ; RA0 analg bemenet !!!
                setf    TRISA   ; PORTA bemenet
                clrf    TRISD           ; PORTD kimenet
                setf    WDTCON  ; watchdog biztosan bekapcsolva (DS39564A pg. 201)
;------------------------------------------------------------------------------
Start
                movlw   0x15
                movwf   LATD            ; 0x55 -> PORTD reset utn
                sleep
;------------------------------------------------------------------------------
                movlw   0xFA
                movwf   LATD            ; 0xAA -> PORTD breszts utn
Stop            bra     Stop            ; vrakozs WDT tlfutsra (vagy resetre)
;------------------------------------------------------------------------------
                end
